package com.sjkj.base_lib.net.request;

import android.content.Context;

import com.sjkj.base_lib.entity.Params;
import com.sjkj.base_lib.entity.ResponseBean;
import com.sjkj.base_lib.net.RetrofitFactory;
import com.sjkj.base_lib.net.data.exception.BusinessException;
import com.sjkj.base_lib.net.domain.interactor.UseCase;
import com.sjkj.base_lib.utils.AppTools;

import rx.Observable;
import rx.functions.Func1;

/**
 * 控制转动摄像头
 */
public class CameraControlRequest extends UseCase {
    private Context context;
    private RetrofitBaseService service;

    private Params params;

    public Params getParams() {
        return params;
    }

    public void setParams(Params params) {
        this.params = params;
    }

    public CameraControlRequest(Context context) {
        this.context = context;
        service = RetrofitFactory.getRetrofit(AppTools.getBaseUrl()).create(RetrofitBaseService.class);
    }

    @Override
    protected Observable buildUseCaseObservable() {
        return service.controlCamera(params).flatMap(new Func1<ResponseBean<Object>, Observable<Object>>() {
            @Override
            public Observable<Object> call(ResponseBean<Object> responseBean) {
                if (!ResponseBean.CODE_SUCCESS.
                        equals(responseBean.getCode())) {
                    return Observable.error(new BusinessException(responseBean.getMsg()));
                }
                return Observable.just(responseBean.getData());
            }
        });
    }
}
